Index: trunk/src/libs/xpcom18a4/xpcom/proxy/public/.cvsignore
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/proxy/public/.cvsignore	(revision 1)
+++ trunk/src/libs/xpcom18a4/xpcom/proxy/public/.cvsignore	(revision 1)
@@ -0,0 +1,1 @@
+Makefile
Index: trunk/src/libs/xpcom18a4/xpcom/proxy/public/Makefile.in
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/proxy/public/Makefile.in	(revision 1)
+++ trunk/src/libs/xpcom18a4/xpcom/proxy/public/Makefile.in	(revision 1)
@@ -0,0 +1,63 @@
+#
+# ***** BEGIN LICENSE BLOCK *****
+# Version: MPL 1.1/GPL 2.0/LGPL 2.1
+#
+# The contents of this file are subject to the Mozilla Public License Version
+# 1.1 (the "License"); you may not use this file except in compliance with
+# the License. You may obtain a copy of the License at
+# http://www.mozilla.org/MPL/
+#
+# Software distributed under the License is distributed on an "AS IS" basis,
+# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
+# for the specific language governing rights and limitations under the
+# License.
+#
+# The Original Code is mozilla.org code.
+#
+# The Initial Developer of the Original Code is
+# Netscape Communications Corporation.
+# Portions created by the Initial Developer are Copyright (C) 1998
+# the Initial Developer. All Rights Reserved.
+#
+# Contributor(s):
+#
+# Alternatively, the contents of this file may be used under the terms of
+# either of the GNU General Public License Version 2 or later (the "GPL"),
+# or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
+# in which case the provisions of the GPL or the LGPL are applicable instead
+# of those above. If you wish to allow use of your version of this file only
+# under the terms of either the GPL or the LGPL, and not to allow others to
+# use your version of this file under the terms of the MPL, indicate your
+# decision by deleting the provisions above and replace them with the notice
+# and other provisions required by the GPL or the LGPL. If you do not delete
+# the provisions above, a recipient may use your version of this file under
+# the terms of any one of the MPL, the GPL or the LGPL.
+#
+# ***** END LICENSE BLOCK *****
+
+DEPTH		= ../../..
+topsrcdir	= @top_srcdir@
+srcdir		= @srcdir@
+VPATH		= @srcdir@
+
+include $(DEPTH)/config/autoconf.mk
+
+MODULE		= xpcom
+ifeq ($(OS_ARCH),WINNT)
+XPIDL_MODULE	= proxyObject
+else
+XPIDL_MODULE	= proxyObjInst
+endif
+
+EXPORTS		= \
+		nsProxyEvent.h \
+		nsProxyRelease.h \
+		nsProxiedService.h \
+		$(NULL)
+
+XPIDLSRCS	= nsIProxyCreateInstance.idl \
+                  nsIProxyObjectManager.idl  \
+                  $(NULL)
+
+include $(topsrcdir)/config/rules.mk
+
Index: trunk/src/libs/xpcom18a4/xpcom/proxy/public/nsProxyEvent.h
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/proxy/public/nsProxyEvent.h	(revision 107935)
+++ trunk/src/libs/xpcom18a4/xpcom/proxy/public/nsProxyEvent.h	(revision 1)
@@ -167,5 +167,5 @@
     PRUint32         mParameterCount;            /* number of params */
     PLEvent         *mEvent;                     /* the current plevent */       
-    volatile bool    mCompleted;                 /* is true when the method has been called. */
+    PRInt32          mCompleted;                 /* is true when the method has been called. */
        
     nsCOMPtr<nsIEventQueue>  mCallersEventQ;     /* this is the eventQ that we must post a message back to 
Index: trunk/src/libs/xpcom18a4/xpcom/proxy/public/nsProxyRelease.h
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/proxy/public/nsProxyRelease.h	(revision 107935)
+++ trunk/src/libs/xpcom18a4/xpcom/proxy/public/nsProxyRelease.h	(revision 1)
@@ -36,8 +36,9 @@
  * ***** END LICENSE BLOCK ***** */
 
-#ifndef nsProxyRelease_h__
+#ifndef nsProxyRelease_h_
 #define nsProxyRelease_h__
 
 #include "nsIEventQueueService.h"
+#include "pratom.h"
 #include "prmem.h"
 
@@ -63,5 +64,5 @@
 {                                                                               \
   NS_PRECONDITION(0 != mRefCnt, "dup release");                                 \
-  nsrefcnt count = ASMAtomicDecU32((volatile uint32_t *)&mRefCnt);              \
+  nsrefcnt count = PR_AtomicDecrement((PRInt32 *)&mRefCnt);                     \
   NS_LOG_RELEASE(this, count, #_class);                                         \
                                                                                 \