Index: /trunk/include/iprt/initterm.h
===================================================================
--- /trunk/include/iprt/initterm.h	(revision 204)
+++ /trunk/include/iprt/initterm.h	(revision 204)
@@ -0,0 +1,93 @@
+/** @file
+ * InnoTek Portable Runtime - Runtime Init/Term.
+ */
+
+/*
+ * Copyright (C) 2006 InnoTek Systemberatung GmbH
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License as published by the Free Software Foundation,
+ * in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
+ * distribution. VirtualBox OSE is distributed in the hope that it will
+ * be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * If you received this file as part of a commercial VirtualBox
+ * distribution, then only the terms of your commercial VirtualBox
+ * license agreement apply instead of the previous paragraph.
+ */
+
+#ifndef __iprt_initterm_h__
+#define __iprt_initterm_h__
+
+#include <iprt/cdefs.h>
+#include <iprt/types.h>
+
+
+__BEGIN_DECLS
+
+/** @defgroup grp_rt    InnoTek Portable Runtime APIs
+ * @{
+ */
+
+/** @defgroup grp_rt_initterm  Init / Term
+ * @{
+ */
+
+#ifdef IN_RING3
+/**
+ * Initalizes the runtime library.
+ *
+ * @returns iprt status code.
+ *
+ * @param   fInitSUPLib     Set if SUPInit() shall be called during init (default).
+ *                          Clear if not to call it.
+ * @param   cbReserve       The number of bytes of contiguous memory that should be reserved by
+ *                          the runtime / support library.
+ *                          Set this to 0 if no reservation is required. (default)
+ *                          Set this to ~(size_t)0 if the maximum amount supported by the VM is to be
+ *                          attempted reserved, or the maximum available.
+ *                          This argument only applies if fInitSUPLib is true and we're in ring-3 HC.
+ */
+RTR3DECL(int) RTR3Init(
+#ifdef __cplusplus
+    bool fInitSUPLib = true,
+    size_t cbReserve = 0
+#else
+    bool fInitSUPLib,
+    size_t cbReserve
+#endif
+    );
+
+/**
+ * Terminates the runtime library.
+ */
+RTR3DECL(void) RTR3Term(void);
+#endif
+
+
+#ifdef IN_RING0
+/**
+ * Initalizes the ring-0 driver runtime library.
+ *
+ * @returns iprt status code.
+ * @param   fReserved       Flags reserved for the future.
+ */
+RTR0DECL(int) RTR0Init(unsigned fReserved);
+
+/**
+ * Terminates the ring-0 driver runtime library.
+ */
+RTR0DECL(void) RTR0Term(void);
+#endif
+
+/** @} */
+
+/** @} */
+
+__END_DECLS
+
+
+#endif
+
Index: /trunk/include/iprt/path.h
===================================================================
--- /trunk/include/iprt/path.h	(revision 203)
+++ /trunk/include/iprt/path.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - Path Manipulation.
  */
Index: /trunk/include/iprt/process.h
===================================================================
--- /trunk/include/iprt/process.h	(revision 203)
+++ /trunk/include/iprt/process.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - Process Management.
  */
Index: /trunk/include/iprt/runtime.h
===================================================================
--- /trunk/include/iprt/runtime.h	(revision 203)
+++ /trunk/include/iprt/runtime.h	(revision 204)
@@ -1,5 +1,4 @@
 /** @file
- *
- * InnoTek Portable Runtime - Runtime Init/Term.
+ * InnoTek Portable Runtime - Include Everything.
  */
 
@@ -20,73 +19,52 @@
  */
 
-#ifndef __iprt_Runtime_h__
-#define __iprt_Runtime_h__
+#ifndef __iprt_runtime_h__
+#define __iprt_runtime_h__
 
 #include <iprt/cdefs.h>
 #include <iprt/types.h>
+#include <iprt/param.h>
+#include <iprt/initterm.h>
 
-
-__BEGIN_DECLS
-
-/** @defgroup grp_rt    InnoTek Portable Runtime APIs
- * @{
- */
-
-/** @defgroup grp_rt_initterm  Init / Term
- * @{
- */
+#include <iprt/alloc.h>
+#include <iprt/asm.h>
+#include <iprt/assert.h>
+#include <iprt/avl.h>
+#include <iprt/crc32.h>
+#include <iprt/crc64.h>
+#include <iprt/critsect.h>
+#include <iprt/dir.h>
+#include <iprt/err.h>
+#include <iprt/file.h>
+#include <iprt/fs.h>
+#include <iprt/ldr.h>
+#include <iprt/log.h>
+#include <iprt/md5.h>
+#include <iprt/mem.h>
+#include <iprt/path.h>
+#include <iprt/semaphore.h>
+#include <iprt/spinlock.h>
+#include <iprt/stdarg.h>
+#include <iprt/string.h>
+#include <iprt/system.h>
+#include <iprt/table.h>
+#include <iprt/thread.h>
+#include <iprt/time.h>
+#include <iprt/timer.h>
+#include <iprt/uni.h>
+#include <iprt/uuid.h>
+#include <iprt/zip.h>
 
 #ifdef IN_RING3
-/**
- * Initalizes the runtime library.
- *
- * @returns iprt status code.
- *
- * @param   fInitSUPLib     Set if SUPInit() shall be called during init (default).
- *                          Clear if not to call it.
- * @param   cbReserve       The number of bytes of contiguous memory that should be reserved by
- *                          the runtime / support library.
- *                          Set this to 0 if no reservation is required. (default)
- *                          Set this to ~(size_t)0 if the maximum amount supported by the VM is to be
- *                          attempted reserved, or the maximum available.
- *                          This argument only applies if fInitSUPLib is true and we're in ring-3 HC.
- */
-RTR3DECL(int) RTR3Init(
-#ifdef __cplusplus
-    bool fInitSUPLib = true,
-    size_t cbReserve = 0
-#else
-    bool fInitSUPLib,
-    size_t cbReserve
-#endif
-    );
-
-/**
- * Terminates the runtime library.
- */
-RTR3DECL(void) RTR3Term(void);
+# include <iprt/stream.h>
+# include <iprt/tcp.h>
+# include <iprt/ctype.h>
+# include <iprt/alloca.h>  /** @todo iprt/alloca.h should be made available in R0 and GC too! */
+# include <iprt/process.h> /** @todo iprt/process.h should be made available in R0 too (partly). */
 #endif
 
-
 #ifdef IN_RING0
-/**
- * Initalizes the ring-0 driver runtime library.
- *
- * @returns iprt status code.
- * @param   fReserved       Flags reserved for the future.
- */
-RTR0DECL(int) RTR0Init(unsigned fReserved);
-
-/**
- * Terminates the ring-0 driver runtime library.
- */
-RTR0DECL(void) RTR0Term(void);
+# include <iprt/memobj.h>
 #endif
-
-/** @} */
-
-/** @} */
-
-__END_DECLS
 
 
Index: /trunk/include/iprt/semaphore.h
===================================================================
--- /trunk/include/iprt/semaphore.h	(revision 203)
+++ /trunk/include/iprt/semaphore.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - Semaphore.
  */
Index: /trunk/include/iprt/spinlock.h
===================================================================
--- /trunk/include/iprt/spinlock.h	(revision 203)
+++ /trunk/include/iprt/spinlock.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - Spinlocks.
  */
@@ -91,5 +90,5 @@
 #ifdef __DOXYGEN__
 # define RTSPINLOCKTMP_INITIALIZER
-#endif 
+#endif
 
 
Index: /trunk/include/iprt/stdarg.h
===================================================================
--- /trunk/include/iprt/stdarg.h	(revision 203)
+++ /trunk/include/iprt/stdarg.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - stdarg.h wrapper.
  */
Index: /trunk/include/iprt/stdint.h
===================================================================
--- /trunk/include/iprt/stdint.h	(revision 203)
+++ /trunk/include/iprt/stdint.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - stdint.h wrapper (for backlevel compilers like MSC).
  */
Index: /trunk/include/iprt/stream.h
===================================================================
--- /trunk/include/iprt/stream.h	(revision 203)
+++ /trunk/include/iprt/stream.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - I/O Stream.
  */
Index: /trunk/include/iprt/string.h
===================================================================
--- /trunk/include/iprt/string.h	(revision 203)
+++ /trunk/include/iprt/string.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - String Manipluation.
  */
Index: /trunk/include/iprt/system.h
===================================================================
--- /trunk/include/iprt/system.h	(revision 203)
+++ /trunk/include/iprt/system.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - System.
  */
Index: /trunk/include/iprt/table.h
===================================================================
--- /trunk/include/iprt/table.h	(revision 203)
+++ /trunk/include/iprt/table.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - Abstract Table/Trees.
  */
Index: /trunk/include/iprt/tcp.h
===================================================================
--- /trunk/include/iprt/tcp.h	(revision 203)
+++ /trunk/include/iprt/tcp.h	(revision 204)
@@ -1,4 +1,3 @@
 /** @file
- *
  * InnoTek Portable Runtime - TCP/IP.
  */
Index: /trunk/include/iprt/uuid.h
===================================================================
--- /trunk/include/iprt/uuid.h	(revision 203)
+++ /trunk/include/iprt/uuid.h	(revision 204)
@@ -26,8 +26,4 @@
 #include <iprt/types.h>
 
-#ifdef IN_RING0
-# error "There are no RTUuid APIs available Ring-0 Host Context!"
-#endif
-
 __BEGIN_DECLS
 
@@ -43,5 +39,5 @@
  * @param   pUuid           Where to store generated uuid.
  */
-RTR3DECL(int)  RTUuidCreate(PRTUUID pUuid);
+RTDECL(int)  RTUuidCreate(PRTUUID pUuid);
 
 /**
@@ -51,5 +47,5 @@
  * @param   pUuid           Where to store generated null uuid.
  */
-RTR3DECL(int)  RTUuidClear(PRTUUID pUuid);
+RTDECL(int)  RTUuidClear(PRTUUID pUuid);
 
 /**
@@ -59,5 +55,5 @@
  * @param   pUuid           uuid to check.
  */
-RTR3DECL(int)  RTUuidIsNull(PCRTUUID pUuid);
+RTDECL(int)  RTUuidIsNull(PCRTUUID pUuid);
 
 /**
@@ -68,5 +64,5 @@
  * @param   pUuid2          Second value to compare.
  */
-RTR3DECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2);
+RTDECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2);
 
 /**
@@ -78,5 +74,5 @@
  * @param   cchString       pszString buffer length, must be >= RTUUID_STR_LENGTH.
  */
-RTR3DECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString);
+RTDECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString);
 
 /**
@@ -87,5 +83,5 @@
  * @param   pszString       String with UUID text data.
  */
-RTR3DECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString);
+RTDECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString);
 
 /** @} */
Index: /trunk/src/VBox/Runtime/generic/uuid-generic.cpp
===================================================================
--- /trunk/src/VBox/Runtime/generic/uuid-generic.cpp	(revision 203)
+++ /trunk/src/VBox/Runtime/generic/uuid-generic.cpp	(revision 204)
@@ -40,5 +40,5 @@
  * @param   pUuid           Where to store generated uuid.
  */
-RTR3DECL(int)  RTUuidCreate(PRTUUID pUuid)
+RTDECL(int)  RTUuidCreate(PRTUUID pUuid)
 {
     /* validate input. */
@@ -66,5 +66,5 @@
  * @param   pUuid           Where to store generated null uuid.
  */
-RTR3DECL(int)  RTUuidClear(PRTUUID pUuid)
+RTDECL(int)  RTUuidClear(PRTUUID pUuid)
 {
     AssertReturn(pUuid, VERR_INVALID_PARAMETER);
@@ -81,5 +81,5 @@
  * @param   pUuid           uuid to check.
  */
-RTR3DECL(int)  RTUuidIsNull(PCRTUUID pUuid)
+RTDECL(int)  RTUuidIsNull(PCRTUUID pUuid)
 {
     AssertReturn(pUuid, VERR_INVALID_PARAMETER);
@@ -96,5 +96,5 @@
  * @param   pUuid2          Second value to compare.
  */
-RTR3DECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2)
+RTDECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2)
 {
     /*
@@ -143,5 +143,5 @@
  * @param   cchString       pszString buffer length, must be >= RTUUID_STR_LENGTH.
  */
-RTR3DECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString)
+RTDECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString)
 {
     /* validate parameters */
@@ -218,5 +218,5 @@
  * @param   pszString       String with UUID text data.
  */
-RTR3DECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString)
+RTDECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString)
 {
     /* 0xff if not a hex number, otherwise the value. (Assumes UTF-8 encoded strings.) */
Index: /trunk/src/VBox/Runtime/r3/linux/uuid-linux.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/linux/uuid-linux.cpp	(revision 203)
+++ /trunk/src/VBox/Runtime/r3/linux/uuid-linux.cpp	(revision 204)
@@ -73,5 +73,5 @@
  * @param   pUuid           Where to store generated uuid.
  */
-RTR3DECL(int)  RTUuidCreate(PRTUUID pUuid)
+RTDECL(int)  RTUuidCreate(PRTUUID pUuid)
 {
     /* check params */
@@ -94,5 +94,5 @@
  * @param   pUuid           Where to store generated null uuid.
  */
-RTR3DECL(int)  RTUuidClear(PRTUUID pUuid)
+RTDECL(int)  RTUuidClear(PRTUUID pUuid)
 {
     /* check params */
@@ -114,5 +114,5 @@
  * @param   pUuid           uuid to check.
  */
-RTR3DECL(int)  RTUuidIsNull(PCRTUUID pUuid)
+RTDECL(int)  RTUuidIsNull(PCRTUUID pUuid)
 {
     /* check params */
@@ -133,5 +133,5 @@
  * @param   pUuid2          Second value to compare.
  */
-RTR3DECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2)
+RTDECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2)
 {
     /* check params */
@@ -153,5 +153,5 @@
  * @param   cchString       pszString buffer length, must be >= RTUUID_STR_LENGTH.
  */
-RTR3DECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString)
+RTDECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString)
 {
     /* check params */
@@ -177,5 +177,5 @@
  * @param   pszString       String with UUID text data.
  */
-RTR3DECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString)
+RTDECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString)
 {
     /* check params */
Index: /trunk/src/VBox/Runtime/r3/win32/uuid-win32.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/win32/uuid-win32.cpp	(revision 203)
+++ /trunk/src/VBox/Runtime/r3/win32/uuid-win32.cpp	(revision 204)
@@ -39,5 +39,5 @@
  * @param   pUuid           Where to store generated uuid.
  */
-RTR3DECL(int)  RTUuidCreate(PRTUUID pUuid)
+RTDECL(int)  RTUuidCreate(PRTUUID pUuid)
 {
     /* check params */
@@ -62,5 +62,5 @@
  * @param   pUuid           Where to store generated null uuid.
  */
-RTR3DECL(int)  RTUuidClear(PRTUUID pUuid)
+RTDECL(int)  RTUuidClear(PRTUUID pUuid)
 {
     /* check params */
@@ -80,5 +80,5 @@
  * @param   pUuid           uuid to check.
  */
-RTR3DECL(int)  RTUuidIsNull(PCRTUUID pUuid)
+RTDECL(int)  RTUuidIsNull(PCRTUUID pUuid)
 {
     /* check params */
@@ -100,5 +100,5 @@
  * @param   pUuid2          Second value to compare.
  */
-RTR3DECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2)
+RTDECL(int)  RTUuidCompare(PCRTUUID pUuid1, PCRTUUID pUuid2)
 {
     /* check params */
@@ -121,5 +121,5 @@
  * @param   cchString       pszString buffer length, must be >= RTUUID_STR_LENGTH.
  */
-RTR3DECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString)
+RTDECL(int)  RTUuidToStr(PCRTUUID pUuid, char *pszString, unsigned cchString)
 {
     /* check params */
@@ -177,5 +177,5 @@
  * @param   pszString       String with UUID text data.
  */
-RTR3DECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString)
+RTDECL(int)  RTUuidFromStr(PRTUUID pUuid, const char *pszString)
 {
     /* check params */