Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h	(revision 260)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h	(revision 261)
@@ -84,5 +84,5 @@
     void onFullscreenChange (bool on);
     
-    void FixModifierState (LONG *codes, uint *count);
+    void fixModifierState (LONG *codes, uint *count);
 
 signals:
@@ -196,7 +196,7 @@
     bool autoresize_guest : 1;
 
-    bool mfNumLock;
-    bool mfScrollLock;
-    bool mfCapsLock;
+    bool mfNumLock : 1;
+    bool mfScrollLock : 1;
+    bool mfCapsLock : 1;
     long muNumLockAdaptionCnt;
     long muCapsLockAdaptionCnt;
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxDefs.h	(revision 260)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxDefs.h	(revision 261)
@@ -148,8 +148,8 @@
         SessionStateChangeEventType = QEvent::User + 7,
         SnapshotEventType = QEvent::User + 8,
-        ModifierKeyChangeEventType = QEvent::User + 9,
+        RuntimeErrorEventType = QEvent::User + 9,
+        ModifierKeyChangeEventType = QEvent::User + 10,
         EnumerateMediaEventType = QEvent::User + 100,
         ActivateMenuEventType = QEvent::User + 101,
-        RuntimeErrorEventType = QEvent::User + 102,
     };
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp	(revision 260)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp	(revision 261)
@@ -200,8 +200,8 @@
     ModifierKeyChangeEvent(bool fNumLock, bool fCapsLock, bool fScrollLock) :
         QEvent ((QEvent::Type) VBoxDefs::ModifierKeyChangeEventType),
-        mfNumLock(fNumLock), mfCapsLock(fCapsLock), mfScrollLock(fScrollLock) {}
-    bool NumLock()    const { return mfNumLock; }
-    bool CapsLock()   const { return mfCapsLock; }
-    bool ScrollLock() const { return mfScrollLock; }
+        mfNumLock (fNumLock), mfCapsLock (fCapsLock), mfScrollLock (fScrollLock) {}
+    bool numLock()    const { return mfNumLock; }
+    bool capsLock()   const { return mfCapsLock; }
+    bool scrollLock() const { return mfScrollLock; }
 private:
     bool mfNumLock, mfCapsLock, mfScrollLock;
@@ -349,4 +349,7 @@
     , ignore_mainwnd_resize (false)
     , autoresize_guest (false)
+    , mfNumLock (false)
+    , mfScrollLock (false)
+    , mfCapsLock (false)
     , muNumLockAdaptionCnt (2)
     , muCapsLockAdaptionCnt (2)
@@ -783,11 +786,11 @@
             {
                 ModifierKeyChangeEvent *me = (ModifierKeyChangeEvent* )e;
-                if (me->NumLock() != mfNumLock)
+                if (me->numLock() != mfNumLock)
                     muNumLockAdaptionCnt = 2;
-                if (me->CapsLock() != mfCapsLock)
+                if (me->capsLock() != mfCapsLock)
                     muCapsLockAdaptionCnt = 2;
-                mfNumLock    = me->NumLock();
-                mfCapsLock   = me->CapsLock();
-                mfScrollLock = me->ScrollLock();
+                mfNumLock    = me->numLock();
+                mfCapsLock   = me->capsLock();
+                mfScrollLock = me->scrollLock();
                 return true;
             }
@@ -1290,5 +1293,5 @@
  *  @param  count  pointer to the keycodes counter
  */
-void VBoxConsoleView::FixModifierState(LONG *codes, uint *count)
+void VBoxConsoleView::fixModifierState(LONG *codes, uint *count)
 {
 #if defined(Q_WS_X11)
@@ -1347,5 +1350,5 @@
 #else
 
-#warning Adapt VBoxConsoleView::FixModifierState
+#warning Adapt VBoxConsoleView::fixModifierState
 
 #endif
@@ -1407,5 +1410,5 @@
                 // CapsLock, ScrollLock) as the X server. If not, send KeyPress events
                 // to synchronize the state.
-                FixModifierState (codes, &count);
+                fixModifierState (codes, &count);
             }
 